/****************************************************************************
 **
 ** Copyright (C) 2013 Digia Plc and/or its subsidiary(-ies).
 ** Contact: http://www.qt-project.org/legal
 **
 ** This file is part of the Qt Mobility Components.
 **
 ** $QT_BEGIN_LICENSE:LGPL$
 ** Commercial License Usage
 ** Licensees holding valid commercial Qt licenses may use this file in
 ** accordance with the commercial license agreement provided with the
 ** Software or, alternatively, in accordance with the terms contained in
 ** a written agreement between you and Digia.  For licensing terms and
 ** conditions see http://qt.digia.com/licensing.  For further information
 ** use the contact form at http://qt.digia.com/contact-us.
 **
 ** GNU Lesser General Public License Usage
 ** Alternatively, this file may be used under the terms of the GNU Lesser
 ** General Public License version 2.1 as published by the Free Software
 ** Foundation and appearing in the file LICENSE.LGPL included in the
 ** packaging of this file.  Please review the following information to
 ** ensure the GNU Lesser General Public License version 2.1 requirements
 ** will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
 **
 ** In addition, as a special exception, Digia gives you certain additional
 ** rights.  These rights are described in the Digia Qt LGPL Exception
 ** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
 **
 ** GNU General Public License Usage
 ** Alternatively, this file may be used under the terms of the GNU
 ** General Public License version 3.0 as published by the Free Software
 ** Foundation and appearing in the file LICENSE.GPL included in the
 ** packaging of this file.  Please review the following information to
 ** ensure the GNU General Public License version 3.0 requirements will be
 ** met: http://www.gnu.org/copyleft/gpl.html.
 **
 **
 ** $QT_END_LICENSE$
 **
 ** This file is part of the Ovi services plugin for the Maps and
 ** Navigation API.  The use of these services, whether by use of the
 ** plugin or by other means, is governed by the terms and conditions
 ** described by the file OVI_SERVICES_TERMS_AND_CONDITIONS.txt in
 ** this package, located in the directory containing the Ovi services
 ** plugin source code.
 **
 ****************************************************************************/
#ifndef QGEOMAPDATA_NOKIA_H
#define QGEOMAPDATA_NOKIA_H

#include <qgeotiledmapdata.h>
#include <QPixmap>
#include <QNetworkReply>

QTM_USE_NAMESPACE

class QGeoMappingManagerEngineNokia;

struct CopyrightDescriptor
{
    qreal maxLevel;
    QString alt;
    QString label;
    qreal minLevel;
    QList<QGeoBoundingBox> boxes;
};

enum LogoPosition
{
    TopLeft = 0,
    ShiftedRight = 1,
    ShiftedDown = 2
};

class QGeoTiledMapDataNokia: public QGeoTiledMapData
{
Q_OBJECT
public:
    QGeoTiledMapDataNokia(QGeoMappingManagerEngineNokia *engine);
    virtual ~QGeoTiledMapDataNokia();
    void paintProviderNotices(QPainter *painter, const QStyleOptionGraphicsItem *option);

    QString getViewCopyright();

private:
    Q_DISABLE_COPY(QGeoTiledMapDataNokia)

    QPixmap watermark;

    QNetworkAccessManager *m_networkManager;

    QHash<QString, QList<CopyrightDescriptor> > copyrights;
    int m_logoPosition;

private slots:
    void copyrightReplyFinished(QNetworkReply*);
};

#endif // QGEOMAPDATA_NOKIA_H
