/****************************************************************************
**
** Copyright (C) 2013 Digia Plc and/or its subsidiary(-ies).
** Contact: http://www.qt-project.org/legal
**
** This file is part of the Qt Mobility Components.
**
** $QT_BEGIN_LICENSE:LGPL$
** Commercial License Usage
** Licensees holding valid commercial Qt licenses may use this file in
** accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and Digia.  For licensing terms and
** conditions see http://qt.digia.com/licensing.  For further information
** use the contact form at http://qt.digia.com/contact-us.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 2.1 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU Lesser General Public License version 2.1 requirements
** will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Digia gives you certain additional
** rights.  These rights are described in the Digia Qt LGPL Exception
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 3.0 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU General Public License version 3.0 requirements will be
** met: http://www.gnu.org/copyleft/gpl.html.
**
**
** $QT_END_LICENSE$
**
****************************************************************************/

#ifndef QGALLERYDBUSINTERFACE_P_H
#define QGALLERYDBUSINTERFACE_P_H

//
//  W A R N I N G
//  -------------
//
// This file is not part of the Qt API. It exists purely as an
// implementation detail. This header file may change from version to
// version without notice, or even be removed.
//
// We mean it.
//

#include <qmobilityglobal.h>

#include <QtCore/qshareddata.h>
#include <QtDBus/qdbusabstractinterface.h>

QTM_BEGIN_NAMESPACE

class QM_AUTOTEST_EXPORT QGalleryDBusInterface : public QDBusAbstractInterface, public QSharedData
{
    Q_OBJECT
public:
    QGalleryDBusInterface(
            const QString &service,
            const QString &path,
            const char *interface,
            const QDBusConnection &connection = QDBusConnection::sessionBus(),
            QObject *parent = 0)
        : QDBusAbstractInterface(service, path, interface, connection, parent) {}
};

typedef QExplicitlySharedDataPointer<QGalleryDBusInterface> QGalleryDBusInterfacePointer;

class QGalleryTrackerDaemonDBusInterface : public QGalleryDBusInterface
{
    Q_OBJECT
public:
    QGalleryTrackerDaemonDBusInterface(
            const QString &service,
            const QString &path,
            const char *interface,
            const QDBusConnection &connection = QDBusConnection::sessionBus(),
            QObject *parent = 0)
        : QGalleryDBusInterface(service, path, interface, connection, parent) {}

Q_SIGNALS:
    void IndexFinished(double elapsed);
    void ServiceStatisticsUpdated(const QVector<QStringList> &statistics);
};

class QGalleryDBusInterfaceFactory
{
public:
    virtual ~QGalleryDBusInterfaceFactory() {}

    virtual QGalleryDBusInterfacePointer daemonInterface() = 0;
    virtual QGalleryDBusInterfacePointer metaDataInterface() = 0;
    virtual QGalleryDBusInterfacePointer searchInterface() = 0;
    virtual QGalleryDBusInterfacePointer fileInterface() = 0;
};

QTM_END_NAMESPACE

#endif
