/****************************************************************************
**
** Copyright (C) 2013 Digia Plc and/or its subsidiary(-ies).
** Contact: http://www.qt-project.org/legal
**
** This file is part of the Qt Mobility Components.
**
** $QT_BEGIN_LICENSE:LGPL$
** Commercial License Usage
** Licensees holding valid commercial Qt licenses may use this file in
** accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and Digia.  For licensing terms and
** conditions see http://qt.digia.com/licensing.  For further information
** use the contact form at http://qt.digia.com/contact-us.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 2.1 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU Lesser General Public License version 2.1 requirements
** will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Digia gives you certain additional
** rights.  These rights are described in the Digia Qt LGPL Exception
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 3.0 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU General Public License version 3.0 requirements will be
** met: http://www.gnu.org/copyleft/gpl.html.
**
**
** $QT_END_LICENSE$
**
****************************************************************************/

#ifndef QVALUESPACEPUBLISHER_H
#define QVALUESPACEPUBLISHER_H

#include "qmobilityglobal.h"
#include "qvaluespace.h"

#include <QObject>
#include <QString>
#include <QUuid>

QT_BEGIN_HEADER

QT_USE_NAMESPACE

QTM_BEGIN_NAMESPACE

class QValueSpacePublisherPrivate;
class Q_PUBLISHSUBSCRIBE_EXPORT QValueSpacePublisher : public QObject
{
    friend class QAbstractValueSpaceLayer;

    Q_OBJECT

public:
    explicit QValueSpacePublisher(const QString &path, QObject *parent = 0);

    QValueSpacePublisher(QValueSpace::LayerOptions filter, const QString &path,
                        QObject *parent = 0);

    QValueSpacePublisher(const QUuid &uuid, const QString &path, QObject *parent = 0);

    virtual ~QValueSpacePublisher();

    QString path() const;

    bool isConnected() const;

    void sync();

Q_SIGNALS:
    void interestChanged(const QString &attribute, bool interested);

public Q_SLOTS:
    void setValue(const QString &name, const QVariant &data);
    void resetValue(const QString &name);

protected:
    virtual void connectNotify(const char *);

private:
    Q_DISABLE_COPY(QValueSpacePublisher)

    QValueSpacePublisherPrivate *d;
};

QTM_END_NAMESPACE

QT_END_HEADER

#endif // QVALUESPACEPUBLISHER_H
